package org.firstinspires.ftc.teamcode;

import com.qualcomm.hardware.rev.RevHubOrientationOnRobot;
import com.qualcomm.robotcore.hardware.DcMotorSimple.Direction;

import org.firstinspires.ftc.teamcode.pedroPathing.localization.Encoder;

public class PedroConstants {

    /*
        Robot parameters
    */

    // Robot motor configurations
    public static final String FRONT_LEFT_MOTOR = "Drive front lt";
    public static final String BACK_LEFT_MOTOR  = "Drive back lt";
    public static final String FRONT_RIGHT_MOTOR  = "Drive front rt";
    public static final String BACK_RIGHT_MOTOR  = "Drive back rt";

    // Robot motor direction
    public static final Direction FRONT_LEFT_MOTOR_DIRECTION = Direction.REVERSE;
    public static final Direction BACK_LEFT_MOTOR_DIRECTION = Direction.REVERSE;
    public static final Direction FRONT_RIGHT_MOTOR_DIRECTION = Direction.REVERSE;
    public static final Direction BACK_RIGHT_MOTOR_DIRECTION = Direction.REVERSE;

    // Robot encoder direction
    public static final double FRONT_LEFT_MOTOR_ENCODER = Encoder.FORWARD;
    public static final double BACK_LEFT_MOTOR_ENCODER = Encoder.FORWARD;
    public static final double FRONT_RIGHT_MOTOR_ENCODER = Encoder.FORWARD;
    public static final double BACK_RIGHT_MOTOR_ENCODER = Encoder.FORWARD;

    /*
        Pedro's parameters
    */

    // The weight of the robot in Kilograms
    public static final double ROBOT_WEIGHT_IN_KG = 5.15;

    // Maximum velocity of the robot going forward
    public static final double ROBOT_SPEED_FORWARD = 57.1750;

    // Maximum velocity of the robot going right
    public static final double ROBOT_SPEED_LATERAL = 52.775;

    // Rate of deceleration when power is cut-off when the robot is moving forward
    public static final double FORWARD_ZERO_POWER_ACCEL = -68.235;

    // Rate of deceleration when power is cut-off when the robot is moving to the right
    public static final double LATERAL_ZERO_POWER_ACCEL = -111.025;

    // Determines how fast your robot will decelerate as a factor of how fast your robot will coast to a stop
    public static final double ZERO_POWER_ACCEL_MULT = 4.0;

    /* Centripetal force correction - increase if robot is correcting into the path
                                    - decrease if robot is correcting away from the path */
    public static final double CENTRIPETAL_SCALING = 0.0004;
}
